=== modified file 'NEWS'
--- NEWS	2009-12-09 17:21:54 +0000
+++ NEWS	2009-12-10 01:30:32 +0000
@@ -118,6 +118,11 @@
 Internals
 *********
 
+* New test Feature: ``ModuleAvailableFeature``. It is designed to make it
+  easier to handle what tests you want to run based on what modules can be
+  imported. (Rather than lots of custom-implemented features that were
+  basically copy-and-pasted.) (John Arbash Meinel)
+
 * Several code paths that were calling ``Transport.get().read()`` have
   been changed to the equalivent ``Transport.get_bytes()``. The main
   difference is that the latter will explicitly call ``file.close()``,

=== modified file 'doc/developers/testing.txt'
--- doc/developers/testing.txt	2009-12-02 20:34:07 +0000
+++ doc/developers/testing.txt	2009-12-09 15:45:37 +0000
@@ -353,6 +353,21 @@
         KnownFailure should be used with care as we don't want a
         proliferation of quietly broken tests.
 
+ModuleAvailableFeature
+        A helper for handling running tests based on whether a python
+        module is available. This can handle 3rd-party dependencies (is
+        ``paramiko`` available?) as well as stdlib (``termios``) or
+        extension modules (``bzrlib._groupcompress_pyx``). You create a
+        new feature instance with::
+
+            MyModuleFeature = ModuleAvailableFeature('bzrlib.something')
+
+            ...
+            def test_something(self):
+                self.requireFeature(MyModuleFeature)
+                something = MyModuleFeature.module
+
+
 We plan to support three modes for running the test suite to control the
 interpretation of these results.  Strict mode is for use in situations
 like merges to the mainline and releases where we want to make sure that

